#define CLOCK 0
#define DATA  3
#define PS_PORT portb

char read_key(char);

char read_key(char timeout)
{
	char count = 0;
	char key = 0;

	while (count < timeout && DATA == 1)
	{
		count++;
	}

	if (count == 255)  return(0);

	while (test_bit(PS_PORT,CLOCK) == 0);

	for (count=0;count<8;count++)
	{
		while (test_bit(PS_PORT,CLOCK) == 1);
		key += test_bit(PS_PORT,DATA) << count;
		while (test_bit(PS_PORT,CLOCK) == 0);
	}

	return (key);
}