#include "p18f252.inc"

		title		"Main program"
		subtitle	""

		list mm=ON,p=pic18f252,r=dec,st=ON,t=OFF,w=2

		org		0x000
		call	video_initialize
		goto	program_main

		org		0x008
		goto	video_interrupt_handler

		org		0x018
		goto	video_interrupt_handler

#include "Video-4MIPS.inc"
#include "Graphics.inc"

program_main
		cls

; Draw a border around the screen:
border	movlw	0x11
		movwf	fcolor
		hline	0,screenwidth,0
		hline	0,screenwidth,screenheight-1
		vline	0,screenheight,0
		vline	0,screenheight,screenwidth-1

loop4ever
		; draw HI
		vline	10,15,4
		vline	10,15,7
		vline	10,15,10
		plot	5,12
		plot	6,12
		hline	9,12,10
		hline	9,12,14
		; next color
		incf	fcolor,F
		movlw	0x0f
		andwf	fcolor,F
		movf	fcolor,W
		swapf	WREG
		iorwf	fcolor,F
		bra		loop4ever

		end
