#define VSYNC 	0x83 //0x83
#define VBP1	0x08 //0x08
#define VBP2	0xFE //0xff
#define HSYNC	0x05 //0x07
#define HBP1	0x04 //0x02
#define HDATA	0x18 //0x18
#define VFP1	0xE3 //0xe3
#define VFP2	0x04 //0x04

void h_sync (void)
{
	trisd = 0x00;
	portd = 0x01;
	char DELAY, DELAY2;
	char INNER, OUTER;

		//Vsync Init
asm		{vsync:
		//V Sync Pulse Start 64us
		bcf _portd, 0}

		HSYNCROUTINE();
		HSYNCROUTINE();
		//V Sync Pulse End

		//V Back Porch Start 1020us
asm		{bsf _portd, 0}
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		//V Back Porch End

		//HSYNCROUTINE Init
		HSYNCROUTINE_init:
asm		{movlw 0x04
		movwf _OUTER

		//HSYNCROUTINE Reset Inner Loop
		HSYNCROUTINE_reset:
		movlw 0x78
		movwf _INNER


		HSYNCROUTINEHSTART:}
		HSYNCROUTINE();

asm		{decfsz _INNER, F
		goto HSYNCROUTINEHSTART
		decfsz _OUTER, F
		goto HSYNCROUTINE_reset}
		//H Front Porch End


		//V Front Porch Start
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		HSYNCROUTINE();
		//V Front Porch End

asm		{goto vsync}


	}
}

void HSYNCROUTINE (void)
{
	asm
	{
		//H Sync Pulse Start 3.77us
		bcf _portd, 1
		movlw HSYNC
		movwf _DELAY
		HSYNCWAIT:
		nop
		decfsz _DELAY, F
		goto HSYNCWAIT
		//H Sync Pulse End
		//H Back Porch Start 1.79 us
		bsf _portd, 1
		movlw HBP1
		movwf _DELAY
		HBACKWAIT:
		nop
		nop
		decfsz _DELAY, F
		goto HBACKWAIT
		//H Back Porch End
		//H Data Area Start 25.42 us
		//nop
		movlw HDATA
		movwf _DELAY
		HDATAWAIT:
		btg _portd, 2
		btg _portd, 5
		btg _portd, 6
		decfsz _DELAY, F
		goto HDATAWAIT
		bcf _portd, 2
		bcf _portd, 5
		bcf _portd, 6
		//nop
		//H Data Area End
		//H Front Porch Start 0.79 us
		nop
		nop
		nop
		nop
		nop
		nop
	}
}