#define VSYNC 	0x83 //0x83
#define VBP1	0x08 //0x08
#define VBP2	0xFE //0xff
#define HSYNC	0x05 //0x07
#define HBP1	0x04 //0x02
#define HDATA	0x18 //0x18
#define VFP1	0xE3 //0xe3
#define VFP2	0x04 //0x04


void h_sync (void)
{
	trisd = 0x00;
	portd = 0x02;
	char DELAY, DELAY2;
	char INNER, OUTER;

	asm
	{
		restart:

		//Hsync Init
				hsync_init:
				movlw 0x04
				movwf _OUTER

				//Hsync Reset Inner Loop
				hsync_reset:
				movlw 0x78
				movwf _INNER

				hsync:


				//H Back Porch Start 1.79 us
				bsf _portd, 1
				movlw HBP1
				movwf _DELAY
				HBACKWAIT:
				nop
				nop
				decfsz _DELAY, F
				goto HBACKWAIT
				//H Back Porch End
				bcf _portd, 1

				//H Front Porch Start 0.79 us
				nop
				nop
				nop
				nop
				nop
				nop
				decfsz _INNER, F
				goto hsync
				decfsz _OUTER, F
				goto hsync_reset
		//H Front Porch End



		goto restart

	}
}